/* ---------- */
/* najifrmt.c */
/* ---------- */

/* naji file format functions */

/* this  .c  file is a part */
/* of libnaji version 0.4.0 */

/* libnaji is based on   */
/* the original najitool */

/* both najitool and libnaji */
/* are public domain and are */
/* made by the same author   */
/* please read license.txt   */

/* made by NECDET COKYAZICI  */

/* charaftr and charbefr  */
/* made by SELCUK OZDOGAN */

/* strbline and streline */
/*   made by POLIKARP    */


#include "libnaji.h"


void charwrap(int w, char *namein, char *nameout)
{
int a;
int b;

najin(namein);
najout(nameout);


       b=0;

       loop
       {

       a = fgetc(naji_input);
       if (a == EOF)
       endloop;

       b++;

       if (b == w || a == '\n')
       {
       fputc('\n', naji_output);
       b=0;
       }

       fputc(a, naji_output);

       }




najinclose();
najoutclose();
}



void wordwrap(char *namein, char *nameout)
{
int i;
int a;
int b;

najin(namein);
najout(nameout);


       b=0;

       loop
       {

       a = fgetc(naji_input);
       if (a == EOF)
       endloop;

       b++;

       if (a == '\n') b=0;


       for (i=0; i<14; i++)
       if ( (b == 65+i) &&

            (  a == ' ' ||
               a == '-' ||
               a == '+' ||
               a == '_' ||
               a == '/' ||
               a == '\\'

             )
          )

       {
       fputc('\n', naji_output);
       b=0;
       break;
       }

       fputc(a, naji_output);

       }




najinclose();
najoutclose();
}


void numlines(char *namein, char *nameout)
{
int a;
unsigned long line = 1;


najin(namein);
najout(nameout);


fprintf(naji_output, "%lu ", line);


   loop
   {

   a = fgetc(naji_input);

   if (a == EOF)
   endloop;

   if (a == '\n')
   {
   line++;
   fprintf(naji_output, "\n%lu ", line);
   }
   else
   fputc(a, naji_output);

   }


najinclose();
najoutclose();
}



void charaftr(char *namein, char *nameout, char ch)
{
int a;

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    
    if (a == EOF)
    endloop;
    
    fputc(a, naji_output);
    fputc(ch, naji_output);
    }

najinclose();
najoutclose();
}


void charbefr(char *namein, char *nameout, char ch)
{
int a;

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);

    if (a == EOF)
    endloop;

    fputc(ch, naji_output);
    fputc(a, naji_output);
    }

najinclose();
najoutclose();
}




void rbcafter(char *namein, char *nameout)
{
int a;

rand_init();

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    
    if (a == EOF)
    endloop;
    
    fputc(a, naji_output);
    fputc(rand() % 255, naji_output);
    }

najinclose();
najoutclose();
}


void rbcbefor(char *namein, char *nameout)
{
int a;

rand_init();

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);

    if (a == EOF)
    endloop;

    fputc(rand() % 255, naji_output);
    fputc(a, naji_output);
    }

najinclose();
najoutclose();
}




void rtcafter(char *namein, char *nameout)
{
int a;

rand_init();

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);
    
    if (a == EOF)
    endloop;
    
    fputc(a, naji_output);
    fputc( ( (rand() % 95)+' ' ), naji_output);
    }

najinclose();
najoutclose();
}


void rtcbefor(char *namein, char *nameout)
{
int a;

rand_init();

najin(namein);
najout(nameout);

    loop
    {
    a = fgetc(naji_input);

    if (a == EOF)
    endloop;

    fputc( ( (rand() % 95)+' ' ), naji_output);
    fputc(a, naji_output);
    }

najinclose();
najoutclose();
}



void strbline(char *namein, char *nameout, char *str)
{
char buffer[4096];
   
najin(namein);
najout(nameout);


   *buffer = '\0';

   while(fgets(buffer, sizeof(buffer), naji_input))
   {
   fprintf(naji_output, "%s%s", str, buffer);
   *buffer = '\0';
   }


najinclose();
najoutclose();
}


void streline(char *namein, char *nameout, char *str)
{
char buffer[4096];
char lastchar=0;
   
najin(namein);
najout(nameout);


   *buffer = '\0';

   while(fgets(buffer, sizeof(buffer), naji_input))
   {
   lastchar = buffer[strlen(buffer)-1];
   buffer[strlen(buffer)-1] ='\0';

   fprintf(naji_output, "%s%s%c",  buffer, str, lastchar);
   *buffer = '\0';
   }


najinclose();
najoutclose();
}


void swapfeb(char *namein, char *namein2, char *nameout)
{
int a;
int b;

  najin(namein);
  najin2(namein2);
  najout(nameout);


   while(1)
   {

   a = fgetc(naji_input);
   fgetc(naji_input2);
   b = fgetc(naji_input2);
   fgetc(naji_input);


   if (a == EOF)
   break;

   if (b == EOF)
   break;

   fputc(a, naji_output);
   fputc(b, naji_output);

   }


  najinclose();
  najin2close();
  najoutclose();
}


void filbreed(char *namein, char *namein2, char *nameout)
{
int a;
int b;

  najin(namein);
  najin2(namein2);
  najout(nameout);


   while(1)
   {

   a = fgetc(naji_input);
   b = fgetc(naji_input2);


   if (a == EOF)
   break;

   if (b == EOF)
   break;

   fputc(a, naji_output);
   fputc(b, naji_output);

   }


  najinclose();
  najin2close();
  najoutclose();
}



void wordline(char *namein, char *nameout)
{
int a;

najin(namein);
najout(nameout);


    loop
    {
    a = fgetc(naji_input);

    if (a == EOF)
    endloop;

    if (a == ' ')
    a = '\n';

    fputc(a, naji_output);
    }


najinclose();
najoutclose();
}

